#include        <stdio.h>
#include        <dir.h>
#include        "c.h"
#include        "expr.h"
#include        "gen.h"
#include        "cglbdec.h"

/*
 *	68000 C compiler
 *
 *	Copyright 1984, 1985, 1986 Matthew Brandt.
 *  all commercial rights reserved.
 *
 *	This compiler is intended as an instructive tool for personal use. Any
 *	use for profit without the written consent of the author is prohibited.
 *
 *	This compiler may be distributed freely for non-commercial use as long
 *	as this notice stays intact. Please forward any enhancements or questions
 *	to:
 *
 *		Matthew Brandt
 *		Box 920337
 *		Norcross, Ga 30092
 */

char            infile[20],
                listfile[20],
                outfile[20];
extern TABLE    tagtable;
int		mainflag;
extern int      total_errors;

int             ArgumentPosition;

main(int argc, char **argv)
{
        ArgumentPosition = 1;
        while (ArgumentPosition < argc) {
                if (argv[ArgumentPosition][0] == '-')
                        options (argv[ArgumentPosition]);
                else if (openfiles (argv[ArgumentPosition]))
                {
                        printf ("Compiling %s\n", ModuleName);
                        lineno = 0;
                        initsym();
                        getch();
                        getsym();
                        compile();
                        summary();
                        release_global();
                        fprintf (output, "\tEND\n");
                        closefiles();
                        }
                ArgumentPosition++;
        }
        return 0;
}

int	options(char *s)
{
        return 0;
}

struct ffblk *f = NULL;

int     openfiles(char *s, int *argc)
{
        /* ATTENTION:  DJGPP */
        #ifndef DJGPP
         #error Please adapt the filesearch part in function 'openfiles', module 'cmain.c'
        #endif

        char    *p;
        int     ofl, lfl, done;


        if (f == NULL)
        {
           f = malloc (sizeof (struct ffblk));
           done = findfirst (s, f, FA_ARCH);
        } else {
           done = findnext (f);
        }

        if (done)
        {
           free (f);
           f = NULL;
           return 0;            /* No more matches, main function has to ignore this */
        }

        strcpy(infile, f->ff_name);
        strcpy(listfile, f->ff_name);
        strcpy(outfile, f->ff_name);
        strcpy (ModuleName, f->ff_name);
        makename(listfile,".lis");
        makename(outfile,".s");
        makename (ModuleName, "");
        if( (input = fopen(infile,"r")) == 0) {
                printf(" cant open %s\n",infile);
                free (f);
                f = NULL;
                return 0;
                }
        if ((output = fopen (outfile, "w")) == NULL)
                {
                printf(" cant create %s\n",outfile);
                fclose(input);
                free (f);
                f = NULL;
                return 0;
                }

        fprintf (output, "; $id %s\n", ModuleName);
        if( (list = fopen(listfile,"w")) == 0) {
                printf(" cant open %s\n",listfile);
                fclose(input);
                fclose(output);
                free (f);
                f = NULL;
                return 0;
                }

        *argc = *argc - 1;     /* Irritate main function  :-) */
        return 1;
}

makename(s,e)
char    *s, *e;
{       while(*s != 0 && *s != '.')
                ++s;
        while(*s++ = *e++);
}

summary()
{       printf("\n -- %d errors found.",total_errors);
        fprintf(list,"\f\n *** global scope symbol table ***\n\n");
        list_table(&gsyms,0);
        fprintf(list,"\n *** structures and unions ***\n\n");
        list_table(&tagtable,0);
}

closefiles()
{       fclose(input);
        fclose(output);
        fclose(list);
}
